<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Scheduler: scheduler.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Scheduler
   &#160;<span id="projectnumber">1.0.0</span>
   </div>
   <div id="projectbrief">Cooperative Scheduler to run tasks</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">scheduler.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="scheduler_8h_source.html">scheduler.h</a>&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a592c67d3184c2d78a8935bb296fdfd4e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="scheduler_8c.html#a592c67d3184c2d78a8935bb296fdfd4e">scheduler_init</a> (<a class="el" href="scheduler_8h.html#acddd0515fc69ad0c3cdb405f4cb9465a">tasks_t</a> *init_tasks, uint16_t size)</td></tr>
<tr class="memdesc:a592c67d3184c2d78a8935bb296fdfd4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Description of <a class="el" href="scheduler_8h.html#a592c67d3184c2d78a8935bb296fdfd4e" title="Description of scheduler_init()">scheduler_init()</a>  <a href="#a592c67d3184c2d78a8935bb296fdfd4e">More...</a><br /></td></tr>
<tr class="separator:a592c67d3184c2d78a8935bb296fdfd4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17d06ef7d87528a418e956cb189f3a78"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="scheduler_8c.html#a17d06ef7d87528a418e956cb189f3a78">scheduler</a> (uint32_t time_ms)</td></tr>
<tr class="memdesc:a17d06ef7d87528a418e956cb189f3a78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Description of <a class="el" href="scheduler_8h.html#a17d06ef7d87528a418e956cb189f3a78" title="Description of scheduler()">scheduler()</a>  <a href="#a17d06ef7d87528a418e956cb189f3a78">More...</a><br /></td></tr>
<tr class="separator:a17d06ef7d87528a418e956cb189f3a78"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac768864df04249e064cb092a0669715d"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="scheduler_8c.html#ac768864df04249e064cb092a0669715d">scheduler_get_size</a> ()</td></tr>
<tr class="memdesc:ac768864df04249e064cb092a0669715d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Description of <a class="el" href="scheduler_8h.html#ac768864df04249e064cb092a0669715d" title="Description of scheduler_get_size()">scheduler_get_size()</a>  <a href="#ac768864df04249e064cb092a0669715d">More...</a><br /></td></tr>
<tr class="separator:ac768864df04249e064cb092a0669715d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a90b86f0816dfd3d615f75b1aa3bd022b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="scheduler_8h.html#acddd0515fc69ad0c3cdb405f4cb9465a">tasks_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="scheduler_8c.html#a90b86f0816dfd3d615f75b1aa3bd022b">tasks</a> [<a class="el" href="scheduler_8h.html#ad70c1074aa802db8cf4a326a7330a6d5">TASKS_N</a>]</td></tr>
<tr class="separator:a90b86f0816dfd3d615f75b1aa3bd022b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22fdd502abe0ce8a6928a95d80f8eb7b"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="scheduler_8c.html#a22fdd502abe0ce8a6928a95d80f8eb7b">t_last</a> [<a class="el" href="scheduler_8h.html#ad70c1074aa802db8cf4a326a7330a6d5">TASKS_N</a>] ={0}</td></tr>
<tr class="separator:a22fdd502abe0ce8a6928a95d80f8eb7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada2ea5c3d8256a4c52703c6778a76cd2"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="scheduler_8c.html#ada2ea5c3d8256a4c52703c6778a76cd2">tasks_size</a></td></tr>
<tr class="separator:ada2ea5c3d8256a4c52703c6778a76cd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a17d06ef7d87528a418e956cb189f3a78"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a17d06ef7d87528a418e956cb189f3a78">&#9670;&nbsp;</a></span>scheduler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void scheduler </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>time_ms</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Description of <a class="el" href="scheduler_8h.html#a17d06ef7d87528a418e956cb189f3a78" title="Description of scheduler()">scheduler()</a> </p>
<p>Starts by verifying if the time_ms has changed. If it was changed saves the data in last_time variable (static variable) and starts the verification process. In that process every task is verified if the period has passed, and if yes it saves the time in the last_time of that task and executes the function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">time_ms</td><td>variable containing time [ms] </td></tr>
  </table>
  </dd>
</dl>
<p>Checks if the time_ms has changed</p>
<p>Saves the new different time</p>
<p>Goes through every task to check if the time passed is &gt;= to the period and if the period is != 0</p>
<p>Saves the "new" last time that the task was executed</p>
<p>Executes the task function </p>

</div>
</div>
<a id="ac768864df04249e064cb092a0669715d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac768864df04249e064cb092a0669715d">&#9670;&nbsp;</a></span>scheduler_get_size()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t scheduler_get_size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Description of <a class="el" href="scheduler_8h.html#ac768864df04249e064cb092a0669715d" title="Description of scheduler_get_size()">scheduler_get_size()</a> </p>
<p>If by any chance the user needs to know the number of tasks he can use this function.</p>
<dl class="section return"><dt>Returns</dt><dd>returns the size saved in the tasks_size </dd></dl>

</div>
</div>
<a id="a592c67d3184c2d78a8935bb296fdfd4e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a592c67d3184c2d78a8935bb296fdfd4e">&#9670;&nbsp;</a></span>scheduler_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void scheduler_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="scheduler_8h.html#acddd0515fc69ad0c3cdb405f4cb9465a">tasks_t</a> *&#160;</td>
          <td class="paramname"><em>init_tasks</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Description of <a class="el" href="scheduler_8h.html#a592c67d3184c2d78a8935bb296fdfd4e" title="Description of scheduler_init()">scheduler_init()</a> </p>
<p>Saves the tasks info in the scheduler own tasks struct, and saves the number of tasks present in the struct</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">init_tasks</td><td>pointer to the tasks_t struct containing the tasks info </td></tr>
    <tr><td class="paramname">size</td><td>unsigned 16 bits integer containing the number of tasks </td></tr>
  </table>
  </dd>
</dl>
<p>Copies the user's tasks array to the scheduler's tasks array</p>
<p>Saves the number of tasks defined by the user </p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a22fdd502abe0ce8a6928a95d80f8eb7b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a22fdd502abe0ce8a6928a95d80f8eb7b">&#9670;&nbsp;</a></span>t_last</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t t_last[<a class="el" href="scheduler_8h.html#ad70c1074aa802db8cf4a326a7330a6d5">TASKS_N</a>] ={0}</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a90b86f0816dfd3d615f75b1aa3bd022b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90b86f0816dfd3d615f75b1aa3bd022b">&#9670;&nbsp;</a></span>tasks</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="scheduler_8h.html#acddd0515fc69ad0c3cdb405f4cb9465a">tasks_t</a> tasks[<a class="el" href="scheduler_8h.html#ad70c1074aa802db8cf4a326a7330a6d5">TASKS_N</a>]</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ada2ea5c3d8256a4c52703c6778a76cd2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada2ea5c3d8256a4c52703c6778a76cd2">&#9670;&nbsp;</a></span>tasks_size</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t tasks_size</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
